<!DOCTYPE html>
<html>

<head>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <!-- Data Table-->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>


    <!-- Các file css và js tự định nghĩa thêm -->
    <link rel="stylesheet" href="style.css">
</head>

<body>
    <div class="container-fluid">
        <div class="form-group">
            <h1 class="text-center">Danh sách Courses</h1>
            <button class="btn btn-info addCourse"> thêm khóa học</button>
        </div>
        <table id="course-table" class=" table table-striped table-bordered table-hover">
            <thead>
                <tr>
                    <th>Id</th>
                    <th>CourseCode</th>
                    <th>CourseName</th>
                    <th>Price</th>
                    <th>DiscountPrice</th>
                    <th>Duration</th>
                    <th>Level</th>
                    <th>CoverImage</th>
                    <th>TeacherName</th>
                    <th>TeacherPhoto</th>
                    <th>isPopular</th>
                    <th>isTrending</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>
    <!-- modal thêm khóa học -->
    <div>
        <div id="add-course-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Thêm khóa học</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="inp-add-course-code">Course Code</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="inp-add-course-code" placeholder="Course Code"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="inp-add-course-name">Course Name</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="inp-add-course-name" placeholder="Course Name"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="inp-add-course-price">Price</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="inp-add-course-price" placeholder="Price"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="inp-add-course-discountprice">discountPrice</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="inp-add-course-discountprice" placeholder="Discount Price"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="inp-add-course-duration">Duration</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="inp-add-course-duration" placeholder="Duration"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="inp-add-course-level">Level</label>
                                </div>
                                <div class="col-sm-8">
                                    <select type="text" id="inp-add-course-level" class="form-control">
                                        <option value="none">--hãy chọn 1 lựa chọn</option>
                                        <option value="Beginner">Beginner</option>
                                        <option value="Intermediate">Intermediate</option>
                                        <option value="Advanced">Advanced</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="inp-add-course-coverimage">Cover Image</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="inp-add-course-coverimage" placeholder="Cover Image"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="inp-add-course-teacherName">Teacher Name</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="inp-add-course-teacherName" placeholder="Teacher Name"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="inp-add-course-teacherPhoto">Teacher Photo</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="inp-add-course-teacherPhoto" placeholder="Teacher Photo"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="inp-add-course-isPopular">Is Popular</label>
                                </div>
                                <div class="col-sm-8">
                                    <select class="form-control" id="inp-add-course-isPopular">
                                        <option value="none">--hãy chọn 1 lựa chọn</option>
                                        <option value="true">True</option>
                                        <option value="false">False</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="inp-add-course-isTrending">Is Trending</label>
                                </div>
                                <div class="col-sm-8">
                                    <select class="form-control" id="inp-add-course-isTrending">
                                        <option value="none">--hãy chọn 1 lựa chọn</option>
                                        <option value="true">True</option>
                                        <option value="false">False</option>
                                    </select>
                                </div>
                            </div>


                        </form>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-success" id="btn-insert-course">Thêm khóa học</button>
                        <button class="btn btn-warning" id="btn-cancel-course" data-dismiss="modal">Hủy bỏ</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- modal Sửa khóa học -->
    <div>
        <div id="change-course-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Thêm khóa học</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="inp-change-course-code">Course Code</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="inp-change-course-code" placeholder="Course Code"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="inp-change-course-name">Course Name</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="inp-change-course-name" placeholder="Course Name"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="inp-change-course-price">Price</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="inp-change-course-price" placeholder="Price"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="inp-change-course-discountprice">discountPrice</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="inp-change-course-discountprice" placeholder="Discount Price"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="inp-change-course-duration">Duration</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="inp-change-course-duration" placeholder="Duration"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="inp-change-course-level">Level</label>
                                </div>
                                <div class="col-sm-8">
                                    <select id="inp-change-course-level" class="form-control">
                                        <option value="none">--hãy chọn 1 lựa chọn--</option>
                                        <option value="Beginner">Beginner</option>
                                        <option value="Intermediate">Intermediate</option>
                                        <option value="Advanced">Advanced</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="inp-change-course-coverimage">Cover Image</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="inp-change-course-coverimage" placeholder="Cover Image"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="inp-change-course-teacherName">Teacher Name</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="inp-change-course-teacherName" placeholder="Teacher Name"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="inp-change-course-teacherPhoto">Teacher Photo</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="inp-change-course-teacherPhoto" placeholder="Teacher Photo"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="inp-change-course-isPopular">Is Popular</label>
                                </div>
                                <div class="col-sm-8">
                                    <select id="inp-change-course-isPopular" class="form-control">
                                        <option value="none">--hãy chọn 1 lựa chọn--</option>
                                        <option value="true">True</option>
                                        <option value="false">False</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="inp-change-course-isTrending">Is Trending</label>
                                </div>
                                <div class="col-sm-8">
                                    <select class="form-control" id="inp-change-course-isTrending">
                                        <option value="none">--hãy chọn 1 lựa chọn</option>
                                        <option value="true">True</option>
                                        <option value="false">False</option>
                                    </select>
                                </div>
                            </div>


                        </form>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-success" id="btn-change-course">Sửa khóa học</button>
                        <button class="btn btn-warning" id="btn-cancel-course" data-dismiss="modal">Hủy bỏ</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- modal xóa khóa học -->
    <div>
        <div id="delete-course-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Xóa khóa học</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="row form-group">
                                <h3>bạn có chắc muốn xóa khóa học này</h3>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-success" id="btn-delete-course">Xóa khóa học</button>
                        <button class="btn btn-secondary" id="btn-cancel-course" data-dismiss="modal">Hủy bỏ</button>
                    </div>
                </div>
            </div>
        </div>
    </div>

</body>
<script>
    /*** REGION 1 - Biến toàn cục */

    var gAllCourses = []
    const gCourseData = ["id", "courseCode", "courseName", "price", "discountPrice", "duration", "level", "coverImage", "teacherName", "teacherPhoto", "isPopular", "isTrending", "action"];
    const gID_COL = 0;
    const gCOURSE_CODE_COL = 1;
    const gCOURSE_NAME_COL = 2;
    const gPRICE_COL = 3;
    const gDISCOUNT_PRICE_COL = 4;
    const gDURATION_COL = 5;
    const gLEVEL_COL = 6;
    const gCOVER_IMAGE_COL = 7;
    const gTEACHER_NAME_COL = 8;
    const gTEACHER_PHOTO_COL = 9;
    const gIS_POPULAR_COL = 10;
    const gIS_TRENDING_COL = 11;
    const gACTION_COL = 12;
    const gBASE_URL = "https://624abe0dfd7e30c51c110ac6.mockapi.io/api/v1/courses/";
    const gCONTENT_TYPE = "application/json;charset=UTF-8";
    var gCourseTable = $("#course-table").DataTable({
        columns: [
            { data: gCourseData[gID_COL] },
            { data: gCourseData[gCOURSE_CODE_COL] },
            { data: gCourseData[gCOURSE_NAME_COL] },
            { data: gCourseData[gPRICE_COL] },
            { data: gCourseData[gDISCOUNT_PRICE_COL] },
            { data: gCourseData[gDURATION_COL] },
            { data: gCourseData[gLEVEL_COL] },
            { data: gCourseData[gCOVER_IMAGE_COL] },
            { data: gCourseData[gTEACHER_NAME_COL] },
            { data: gCourseData[gTEACHER_PHOTO_COL] },
            { data: gCourseData[gIS_POPULAR_COL] },
            { data: gCourseData[gIS_TRENDING_COL] },
            { data: gCourseData[gACTION_COL] },
        ],
        columnDefs: [
            {
                targets: gACTION_COL,
                defaultContent: `
                <button class="btn btn-success btn-change">Sửa</button>
                <button class="btn btn-secondary btn-delete">Xóa</button>                                `
            },
            {
                targets: gCOVER_IMAGE_COL,
                data:"img",
                render: function(data) {
                    return '<img src="' + data + '" alt="' + data +'"height="100%" width="100%"/>';
                }
            },
            {
                targets: gTEACHER_PHOTO_COL,
                data:"img",
                render: function(data) {
                    return '<img src="' + data + '" alt="' + data +'"height="25%" width="25%" class="rounded-circle "/>';
                }
            }

        ]
    })
    var gCourseChange = {};
    var gIdCourseChange = 0;
    var gIdCourseDelete = 0;

    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    $(document).ready(function () {

    })
    // hàm khi vừa tải trang
    onPageLoading();
    // hàm xử lý sự kiện nhấn nút thêm khóa học
    $(".addCourse").click(function () {
        $("#add-course-modal").modal("show");
    })
    // hàm xử lý khi nhấn nút sửa
    $("#course-table").on("click", ".btn-change", function () {
        // hiện modal
        $("#change-course-modal").modal("show");
        // gán thông tin của khóa học cần sửa vào modal
        addDataCourseChangeToModal(this);
    })
    // hàm xử lý khi nhấn nút thêm khóa học
    $("#btn-insert-course").click(function () {
        //debugger;
        var vNewCourse = {
            id: "",
            courseCode: "",
            courseName: "",
            price: 0,
            discountPrice: 0,
            duration: "",
            level: "",
            coverImage: "",
            teacherName: "",
            teacherPhoto: "",
            isPopular: "",
            isTrending: ""
        }
        // bước 1 thu thập dữ liệu
        getDataCourse(vNewCourse);
        // bước 2 kiểm tra
        var vValiDateNewCourse = valiDateNewCourse(vNewCourse);
        // bước 3 thêm vào mảng toàn cục
        if (vValiDateNewCourse) {
            $.ajax({
                url: gBASE_URL,
                type: "POST",
                contentType: gCONTENT_TYPE,
                data: JSON.stringify(vNewCourse),
                success: function (paramRes) {
                    // B4: xử lý front-end
                    handleInsertCourseSuccess()
                },
                error: function (paramErr) {
                    console.log(paramErr.status);
                }
            });



        }
    })

    // hàm xử lý khi nhân nút sửa khóa học
    $("#btn-change-course").click(function () {
        // debugger;
        var vChangeCourse = {
            id: "",
            courseCode: "",
            courseName: "",
            price: 0,
            discountPrice: 0,
            duration: "",
            level: "",
            coverImage: "",
            teacherName: "",
            teacherPhoto: "",
            isPopular: "",
            isTrending: ""
        }
        // thu thập dữ liệu từ form
        getDataChangeCourse(vChangeCourse)
        // kiểm tra dữ liệu khóa học muốn sửa
        var vValiDateChangeCourse = valiDateChangeCourse(vChangeCourse);
        // bước 3 thêm vào mảng toàn cục
        if (vValiDateChangeCourse) {
            $.ajax({
                url: gBASE_URL + vChangeCourse.id,
                type: "PUT",
                contentType: gCONTENT_TYPE,
                data: JSON.stringify(vChangeCourse),
                success: function (paramRes) {
                    handleChangeCourseSuccess()
                },
                error: function (paramErr) {
                    console.log(paramErr.status);
                }
            });
        }
    })

    // hàm xử lý khi nhấn nút xóa
    $("#course-table").on("click", ".btn-delete", function () {
        // hiện modal
        $("#delete-course-modal").modal("show");
        var vCourseDelete = gCourseTable.row($(this).parents("tr")).data();
        gIdCourseDelete = vCourseDelete.id;
    })
    // hàm xử lý khi nhấn nút xóa khóa học

    $("#btn-delete-course").click(function () {
        $.ajax({
            url: gBASE_URL + gIdCourseDelete,
            type: "DELETE",

            success: function (paramRes) {
                handleDeleteCourseSuccess()
            },
            error: function (paramErr) {
                console.log(paramErr.status);
            }
        });


    })

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        $.ajax({
            url: gBASE_URL,
            type: 'GET',
            dataType: 'json', // added data type
            success: function (responseObject) {
                gAllCourses = responseObject;
                console.log(responseObject);
                loadDataIntoTable(gAllCourses);
            },
            error: function (ajaxContext) {
                alert(ajaxContext.responseText)
            }
        });
    }
    // hàm hiện thông tin lên bảng
    function loadDataIntoTable(paramCourse) {
        gCourseTable.clear();
        gCourseTable.rows.add(paramCourse);
        gCourseTable.draw();
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // hàm lấy dữ liệu trên form
    function getDataCourse(paramForm) {
        paramForm.courseCode = $("#inp-add-course-code").val().trim()
        paramForm.courseName = $("#inp-add-course-name").val().trim()
        paramForm.price = $("#inp-add-course-price").val().trim()
        paramForm.discountPrice = $("#inp-add-course-discountprice").val().trim()
        paramForm.duration = $("#inp-add-course-duration").val().trim()
        paramForm.level = $("#inp-add-course-level").val().trim()
        paramForm.coverImage = $("#inp-add-course-coverimage").val().trim()
        paramForm.teacherName = $("#inp-add-course-teacherName").val().trim()
        paramForm.teacherPhoto = $("#inp-add-course-teacherPhoto").val().trim()
        paramForm.isPopular = $("#inp-add-course-isPopular").val()
        paramForm.isTrending = $("#inp-add-course-isTrending").val()
    }
    // hàm lấy dữ liệu trên form
    function getDataChangeCourse(paramChangeCourse) {
        paramChangeCourse.id = gIdCourseChange;
        paramChangeCourse.courseCode = $("#inp-change-course-code").val().trim()
        paramChangeCourse.courseName = $("#inp-change-course-name").val().trim()
        paramChangeCourse.price = $("#inp-change-course-price").val().trim()
        paramChangeCourse.discountPrice = $("#inp-change-course-discountprice").val().trim()
        paramChangeCourse.duration = $("#inp-change-course-duration").val().trim()
        paramChangeCourse.level = $("#inp-change-course-level").val()
        paramChangeCourse.coverImage = $("#inp-change-course-coverimage").val().trim()
        paramChangeCourse.teacherName = $("#inp-change-course-teacherName").val().trim()
        paramChangeCourse.teacherPhoto = $("#inp-change-course-teacherPhoto").val().trim()
        paramChangeCourse.isPopular = $("#inp-change-course-isPopular").val()
        paramChangeCourse.isTrending = $("#inp-change-course-isTrending").val()
    }
    // hàm kiểm tra thông tin từ form thêm phần tử
    function valiDateNewCourse(paramNewCourse) {
        if (paramNewCourse.courseCode == "") {
            alert("hãy nhập mã khóa học!");
            return false;
        }
        for (var i = 0; i < gAllCourses.length; i++) {
            if (gAllCourses[i].courseCode === paramNewCourse.courseCode) {
                alert("mã khóa học đã tồn tại!");
                return false;
            }
        }

        if (paramNewCourse.courseName == "") {
            alert("hãy nhập tên khóa học!");
            return false;
        }

        if (paramNewCourse.price == "") {
            alert("hãy nhập Giá niêm yết của khóa học, chưa giảm!");
            return false;
        }

        if (isNaN(paramNewCourse.price)) {
            alert("hãy nhập Giá niêm yết của khóa học, chưa giảm là số!")
            return false;
        }

        if (paramNewCourse.price <= 0) {
            alert("hãy nhập Giá niêm yết của khóa học, chưa giảm là số lớn hơn 0!");
            return false;
        }


        if (paramNewCourse.discountPrice == "") {
            alert("hãy nhập Giá bán thực tế, giảm so với giá gốc !");
            return false;
        }

        if (isNaN(paramNewCourse.discountPrice)) {
            alert("hãy nhập Giá bán thực tế, giảm so với giá gốc là số!")
            return false;
        }

        if (paramNewCourse.discountPrice < 0) {
            alert("hãy nhập Giá bán thực tế, giảm so với giá gốc là số lớn hơn 0!");
            return false;
        }

        if (paramNewCourse.duration == "") {
            alert("hãy nhập Độ dài của khóa học!");
            return false;
        }

        if (paramNewCourse.level == "none") {
            alert("hãy nhập trình độ của khóa học!");
            return false;
        }

        if (paramNewCourse.coverImage == "") {
            alert("hãy nhập Ảnh nền của khóa học!");
            return false;
        }

        if (paramNewCourse.teacherName == "") {
            alert("hãy nhập tên đầy đủ của giảng viên!");
            return false;
        }

        if (paramNewCourse.teacherPhoto == "") {
            alert("hãy nhập Ảnh profile của giảng viên!");
            return false;
        }

        if (paramNewCourse.isPopular == "none") {
            alert("hãy chọn Để xác định xem course có nằm trong course popular hay không?!");
            return false;
        }

        if (paramNewCourse.isTrending == "none") {
            alert("hãy chọn Để xác định xem course có nằm trong course trending hay không?!");
            return false;
        }
        return true;
    }

    // hàm kiểm tra thông tin từ form (sủa phần tử)
    function valiDateChangeCourse(paramNewCourse) {
        if (paramNewCourse.courseCode == "") {
            alert("hãy nhập mã khóa học!");
            return false;
        }


        if (paramNewCourse.courseName == "") {
            alert("hãy nhập tên khóa học!");
            return false;
        }

        if (paramNewCourse.price == "") {
            alert("hãy nhập Giá niêm yết của khóa học, chưa giảm!");
            return false;
        }

        if (isNaN(paramNewCourse.price)) {
            alert("hãy nhập Giá niêm yết của khóa học, chưa giảm là số!")
            return false;
        }

        if (paramNewCourse.price <= 0) {
            alert("hãy nhập Giá niêm yết của khóa học, chưa giảm là số lớn hơn 0!");
            return false;
        }


        if (paramNewCourse.discountPrice == "") {
            alert("hãy nhập Giá bán thực tế, giảm so với giá gốc !");
            return false;
        }

        if (isNaN(paramNewCourse.discountPrice)) {
            alert("hãy nhập Giá bán thực tế, giảm so với giá gốc là số!")
            return false;
        }

        if (paramNewCourse.discountPrice < 0) {
            alert("hãy nhập Giá bán thực tế, giảm so với giá gốc là số lớn hơn 0!");
            return false;
        }

        if (paramNewCourse.duration == "") {
            alert("hãy nhập Độ dài của khóa học!");
            return false;
        }

        if (paramNewCourse.level == "none") {
            alert("hãy nhập trình độ của khóa học!");
            return false;
        }

        if (paramNewCourse.coverImage == "") {
            alert("hãy nhập Ảnh nền của khóa học!");
            return false;
        }

        if (paramNewCourse.teacherName == "") {
            alert("hãy nhập tên đầy đủ của giảng viên!");
            return false;
        }

        if (paramNewCourse.teacherPhoto == "") {
            alert("hãy nhập Ảnh profile của giảng viên!");
            return false;
        }

        if (paramNewCourse.isPopular == "none") {
            alert("hãy chọn Để xác định xem course có nằm trong course popular hay không?!");
            return false;
        }

        if (paramNewCourse.isTrending == "none") {
            alert("hãy chọn Để xác định xem course có nằm trong course trending hay không?!");
            return false;
        }
        return true;
    }
    // hàm xử lý hiển thị front-end khi thêm course thành công
    function handleInsertCourseSuccess() {
        alert("Thêm Courses thành công!");
        // xóa trắng modal
        resetFormModal();
        onPageLoading();
        // load lại bảng
        loadDataIntoTable(gAllCourses)
        // ẩn modal 
        $("#add-course-modal").modal("hide")
    }
    // hàm xử lý hiển thị front-end khi sửa course thành công
    function handleChangeCourseSuccess() {
        alert("Sửa Courses thành công!");
        // load lại bảng
         loadDataIntoTable(gAllCourses);
        onPageLoading();
        // ẩn modal 
        $("#change-course-modal").modal("hide")
    }
    // hàm xử lý hiển thị front-end khi xóa course thành công
    function handleDeleteCourseSuccess() {
        alert("Xóa Courses thành công!");
        // load lại bảng
       // loadDataIntoTable(gAllCourses);
         onPageLoading();
        // ẩn modal 
        $("#delete-course-modal").modal("hide")
    }


    // hàm xóa trắng form modal
    function resetFormModal() {
        $("#inp-add-course-code").val("");
        $("#inp-add-course-name").val("");
        $("#inp-add-course-price").val("");
        $("#inp-add-course-discountprice").val("");
        $("#inp-add-course-duration").val("");
        $("#inp-add-course-level").val("");
        $("#inp-add-course-coverimage").val("");
        $("#inp-add-course-teacherName").val("");
        $("#inp-add-course-teacherPhoto").val("");
        $("#inp-add-course-isPopular").val("");
        $("#inp-add-course-isTrending").val("");
    }
    // hàm xử lý hiện thông tin của khóa học cần sửa lên modal
    function addDataCourseChangeToModal(paramBtnChange) {
        // debugger;
        var gCourseChange = gCourseTable.row($(paramBtnChange).parents("tr")).data();
        console.log(gCourseChange);
        gIdCourseChange = gCourseChange.id;
        $("#inp-change-course-code").val(gCourseChange.courseCode);
        $("#inp-change-course-name").val(gCourseChange.courseName);
        $("#inp-change-course-price").val(gCourseChange.price);
        $("#inp-change-course-discountprice").val(gCourseChange.discountPrice);
        $("#inp-change-course-duration").val(gCourseChange.duration);
        $("#inp-change-course-level").val(gCourseChange.level);
        $("#inp-change-course-coverimage").val(gCourseChange.coverImage);
        $("#inp-change-course-teacherName").val(gCourseChange.teacherName);
        $("#inp-change-course-teacherPhoto").val(gCourseChange.teacherPhoto);
        $("#inp-change-course-isPopular").val(String(gCourseChange.isPopular));
        $("#inp-change-course-isTrending").val(String(gCourseChange.isTrending));
    }

</script>

</html>